package net.cephas.dwr;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;

import uk.ltd.getahead.dwr.Configuration;
import uk.ltd.getahead.dwr.DWRServlet;
import uk.ltd.getahead.dwr.util.Logger;


public class FluentDWRServlet extends DWRServlet {
	
	private static final Logger log = Logger.getLogger(FluentDWRServlet.class);
    
	
	public void configure(ServletConfig config, Configuration configuration) throws ServletException {
			
			log.info("starting configuration using FluentConfiguration");
		
			if (configuration instanceof FluentConfiguration) {
				FluentConfiguration fluentconfig = (FluentConfiguration)configuration;
				fluentconfig
					.withConverterType("testbean", "uk.ltd.getahead.testdwr.TestBean2Converter")
					.withCreator("new", "Test")
						.addParam("scope", "application")
						.addParam("class", "uk.ltd.getahead.testdwr.Test")
					.withCreator("new", "JDate")
						.addParam("class", "java.util.Date")
						.exclude("getHours")
						.withAuth("getMinutes", "admin")
						.withAuth("getMinutes", "devel")
					.withConverter("bean", "$Proxy*")
					.withConverter("testbean", "uk.ltd.getahead.testdwr.TestBean")
					.withConverter("bean", "uk.ltd.getahead.testdwr.ObjB")
					.withConverter("object", "uk.ltd.getahead.testdwr.ObjA")
						.addParam("force", "true")
					.withSignature()
						.addLine("import java.util.*;")		 
						.addLine("import uk.ltd.getahead.testdwr.*;")
						.addLine("Test.testBeanSetParam(Set<TestBean>);")
						.addLine("Test.testBeanListParam(List<TestBean>);")
						.addLine("Test.charTestBeanMapParam(Map<Character, TestBean>);")
						.addLine("Test.stringStringMapParam(Map<String, String>);")
						.addLine("Test.stringStringHashMapParam(HashMap<String, String>);")
						.addLine("Test.stringStringTreeMapParam(TreeMap<String, String>);")
						.addLine("Test.stringCollectionParam(Collection<String>);")
						.addLine("Test.stringListParam(List<String>);")
						.addLine("Test.stringLinkedListParam(LinkedList<String>);")
						.addLine("Test.stringArrayListParam(ArrayList<String>);")
						.addLine("Test.stringSetParam(Set<String>);")
						.addLine("Test.stringHashSetParam(HashSet<String>);")
						.addLine("Test.stringTreeSetParam(TreeSet<String>);")
					.finished();
			}
	}
}
